← Back to results

HTTP/1

.1 200 OK date: Thu, 02 Jul 2026 17:19:37 GMT server: mw-web.codfw.main-59769c4d9b-zrfxf x-content-type-options: nosniff content-language: en accept-ch: reporting-endpoints: csp-report-to-endpoint='/w/api.php?action=cspreport&format=json'; content-security-policy: script-src 'unsafe-eval' blob: 'self' meta.wikimedia.org *.wikimedia.org *.wikipedia.org *.wikinews.org *.wiktionary.org *.wikibooks.org *.wikiversity.org *.wikisource.org wikisource.org *.wikiquote.org *.wikidata.org *.wikifunctions.org *.wikivoyage.org *.mediawiki.org mediawiki.org wikimedia.org *.wmflabs.org *.wmcloud.org *.toolforge.org wss://*.toolforge.org *.jsdelivr.net unpkg.com cdnjs.cloudflare.com raw.githubusercontent.com *.github.com code.jquery.com cdn.mathjax.org use.typekit.net fonts.cdnfonts.com use.fontawesome.com i.ytimg.com rsms.me doi.org localhost https://localhost:* http://localhost:* wss://localhost:* ws://localhost:* *.google.com *.gstatic.com *.googleapis.com *.translate.yandex.net yastatic.net ya.ru radically.github.io cdn.sammdot.ca cdn.fontshare.com viaf.org publicai-proxy.alaexis.workers.dev iiif.archive.org api.flickr.com live.staticflickr.com api.anthropic.com api.openai.com api.publicai.co catalogo.pusc.it parsifal.urbe.it opac.sbn.it overpass-api.de api.openrouteservice.org archive.org *.openstreetmap.org *.waymarkedtrails.org *.thunderforest.com registry.ipe.wiki analytics.ipe.wiki qlever.dev app.goacoustic.com wikipedia-archive.ourworldindata.org api.inaturalist.org inaturalist-open-data.s3.amazonaws.com validator.w3.org db.onlinewebfonts.com fontlibrary.org 'unsafe-inline' auth.wikimedia.org; default-src 'self' data: blob: upload.wikimedia.org https://commons.wikimedia.org meta.wikimedia.org *.wikimedia.org *.wikipedia.org *.wikinews.org *.wiktionary.org *.wikibooks.org *.wikiversity.org *.wikisource.org wikisource.org *.wikiquote.org *.wikidata.org *.wikifunctions.org *.wikivoyage.org *.mediawiki.org mediawiki.org wikimedia.org *.wmflabs.org *.wmcloud.org *.toolforge.org wss://*.toolforge.org *.jsdelivr.net unpkg.com cdnjs.cloudflare.com raw.githubusercontent.com *.github.com code.jquery.com cdn.mathjax.org use.typekit.net fonts.cdnfonts.com use.fontawesome.com i.ytimg.com rsms.me doi.org localhost https://localhost:* http://localhost:* wss://localhost:* ws://localhost:* *.google.com *.gstatic.com *.googleapis.com *.translate.yandex.net yastatic.net ya.ru radically.github.io cdn.sammdot.ca cdn.fontshare.com viaf.org publicai-proxy.alaexis.workers.dev iiif.archive.org api.flickr.com live.staticflickr.com api.anthropic.com api.openai.com api.publicai.co catalogo.pusc.it parsifal.urbe.it opac.sbn.it overpass-api.de api.openrouteservice.org archive.org *.openstreetmap.org *.waymarkedtrails.org *.thunderforest.com registry.ipe.wiki analytics.ipe.wiki qlever.dev app.goacoustic.com wikipedia-archive.ourworldindata.org api.inaturalist.org inaturalist-open-data.s3.amazonaws.com validator.w3.org db.onlinewebfonts.com fontlibrary.org en.wikibooks.org en.wikinews.org en.wikiquote.org en.wikisource.org en.wikiversity.org en.wikivoyage.org en.wiktionary.org www.mediawiki.org commons.wikimedia.org foundation.wikimedia.org incubator.wikimedia.org species.wikimedia.org wikimania.wikimedia.org www.wikidata.org www.wikifunctions.org auth.wikimedia.org; style-src 'self' data: blob: upload.wikimedia.org https://commons.wikimedia.org meta.wikimedia.org *.wikimedia.org *.wikipedia.org *.wikinews.org *.wiktionary.org *.wikibooks.org *.wikiversity.org *.wikisource.org wikisource.org *.wikiquote.org *.wikidata.org *.wikifunctions.org *.wikivoyage.org *.mediawiki.org mediawiki.org wikimedia.org *.wmflabs.org *.wmcloud.org *.toolforge.org wss://*.toolforge.org *.jsdelivr.net unpkg.com cdnjs.cloudflare.com raw.githubusercontent.com *.github.com code.jquery.com cdn.mathjax.org use.typekit.net fonts.cdnfonts.com use.fontawesome.com i.ytimg.com rsms.me doi.org localhost https://localhost:* http://localhost:* wss://localhost:* ws://localhost:* *.google.com *.gstatic.com *.googleapis.com *.translate.yandex.net yastatic.net ya.ru radically.github.io cdn.sammdot.ca cdn.fontshare.com viaf.org publicai-proxy.alaexis.workers.dev iiif.archive.org api.flickr.com live.staticflickr.com api.anthropic.com api.openai.com api.publicai.co catalogo.pusc.it parsifal.urbe.it opac.sbn.it overpass-api.de api.openrouteservice.org archive.org *.openstreetmap.org *.waymarkedtrails.org *.thunderforest.com registry.ipe.wiki analytics.ipe.wiki qlever.dev app.goacoustic.com wikipedia-archive.ourworldindata.org api.inaturalist.org inaturalist-open-data.s3.amazonaws.com validator.w3.org db.onlinewebfonts.com fontlibrary.org 'unsafe-inline'; object-src 'none'; report-uri /w/api.php?action=cspreport&format=json; report-to csp-report-to-endpoint last-modified: Sun, 21 Jun 2026 21:47:44 GMT content-type: text/html; charset=UTF-8 age: 82072 accept-ranges: bytes x-cache: cp2047 miss, cp2047 hit/4 x-cache-status: hit-front server-timing: cache;desc="hit-front", host;desc="cp2047" strict-transport-security: max-age=106384710; includeSubDomains; preload report-to: { "group": "wm_nel", "max_age": 604800, "endpoints": [{ "url": "https://intake-logging.wikimedia.org/v1/events?stream=w3c.reportingapi.network_error&schema_uri=/w3c/reportingapi/network_error/1.0.0" }] } nel: { "report_to": "wm_nel", "max_age": 604800, "failure_fraction": 0.05, "success_fraction": 0.0} set-cookie: WMF-Last-Access=03-Jul-2026;Path=/;HttpOnly;secure;Expires=Tue, 04 Aug 2026 12:00:00 GMT set-cookie: WMF-Last-Access-Global=03-Jul-2026;Path=/;Domain=.wikipedia.org;HttpOnly;secure;Expires=Tue, 04 Aug 2026 12:00:00 GMT set-cookie: WMF-DP=b05;Path=/;HttpOnly;secure;Expires=Sat, 04 Jul 2026 00:00:00 GMT x-client-ip: 75.28.18.94 cache-control: private, s-maxage=0, max-age=0, must-revalidate, no-transform vary: Accept-Encoding,X-Subdomain,Cookie,Authorization,User-Agent set-cookie: GeoIP=US:TX:McKinney:33.20:-96.62:v4; Path=/; secure; Domain=.wikipedia.org set-cookie: NetworkProbeLimit=0.001;Path=/;Secure;SameSite=None;Max-Age=3600 set-cookie: WMF-Uniq=gHb2DjsAWiw25WYlHfkX6gOSAAAAAFvdrARYE1-187IouATjW7Pxtmaeo_HKIjIX;Domain=.wikipedia.org;Path=/;HttpOnly;secure;SameSite=None;Expires=Sat, 03 Jul 2027 00:00:00 GMT content-length: 280691 x-request-id: 2ee4fe07-ccaa-4c4d-9ee3-24784a406423 x-analytics: Internet Control Message Protocol - Wikipedia Jump to content Main menu Main menu move to sidebar hide Navigation Main page Contents Current events Random article About Wikipedia Contact us Contribute Help Learn to edit Community portal Recent changes Upload file Special pages Search Search Appearance Donate Create account Log in Personal tools Donate Create account Log in Contents move to sidebar hide (Top) 1 Technical details 2 Datagram structure Toggle Datagram structure subsection 2.1 Header 2.2 Data 3 Control messages Toggle Control messages subsection 3.1 Source quench 3.2 Redirect 3.3 Time exceeded 3.4 Timestamp 3.5 Timestamp reply 3.6 Address mask request 3.7 Address mask reply 3.8 Destination unreachable 4 Extensions 5 See also 6 References 7 External links Toggle the table of contents Internet Control Message Protocol 45 languages Aragonés العربية Български Bosanski Català Čeština Dansk Deutsch Ελληνικά Esperanto Español Eesti Euskara فارسی Suomi Français Galego עברית Hrvatski Magyar Bahasa Indonesia Italiano 日本語 한국어 Lombard Lietuvių Latviešu Македонски മലയാളം Nederlands Norsk bokmål Polski Português Română Русский Slovenčina Slovenščina Српски / srpski Svenska ไทย Türkçe Українська Tiếng Việt Yorùbá 中文 Edit links Article Talk English Read Edit View history Tools Tools move to sidebar hide Actions Read Edit View history General What links here Related changes Upload file Permanent link Page information Cite this page Get shortened URL Switch to legacy parser Print/export Download as PDF Printable version In other projects Wikimedia Commons Wikidata item Appearance move to sidebar hide From Wikipedia, the free encyclopedia Internet protocol used for error messages in network operations This article is about the support protocol for IPv4 (ICMPv4). For ICMPv6, see ICMPv6 . "ICMP" redirects here. For other uses, see ICMP (disambiguation) . Internet Control Message Protocol Communication protocol A general header for ICMPv4 Purpose Auxiliary protocol for IPv4 [ 1 ] :   52   Developer DARPA Introduction 1981 ; 45   years ago   ( 1981 ) OSI layer Network layer IP number 1 RFC 792 The Internet Control Message Protocol ( ICMP ) is a supporting protocol [ 2 ] in the Internet protocol suite . It is used by network devices , including routers , to send error messages and operational information indicating success or failure when communicating with another IP address . For example, an error is indicated when a requested service is not available or that a host or router could not be reached. [ 3 ] ICMP differs from transport protocols such as TCP and UDP in that it is not typically used to exchange data between systems, nor is it regularly employed by end-user network applications (with the exception of some diagnostic tools like ping and traceroute ). A separate Internet Control Message Protocol (called ICMPv6 ) is used with IPv6 . [ 4 ] Internet protocol suite Application layer BGP DHCP ( v6 ) DNS FTP HTTP   ( HTTP/3 ) HTTPS IMAP IPP IRC LDAP MGCP MQTT NNTP NTP OSPF POP PTP ONC/RPC RTP RTSP RIP SIP SMTP SNMP SSH Telnet TLS/SSL XMPP more... Transport layer TCP UDP DCCP SCTP RSVP QUIC more... Internet layer IP v4 v6 ICMP ( v6 ) NDP ECN L4S IGMP IPsec more... Link layer ARP Tunnels PPP MAC more... v t e Technical details [ edit ] ICMP is part of the Internet protocol suite as defined in RFC 792. ICMP messages are typically used for diagnostic or control purposes or generated in response to errors in IP operations (as specified in RFC 1122). ICMP errors are directed to the source IP address of the originating packet. [ 3 ] For example, every device (such as an intermediate router ) forwarding an IP datagram first decrements the time to live (TTL) field in the IP header by one. If the resulting TTL is 0, the packet is discarded and an ICMP time exceeded message is sent to the datagram's source address. Many commonly used network utilities are based on ICMP messages. The traceroute command can be implemented by transmitting IP datagrams with specially set IP TTL header fields, and looking for ICMP time exceeded in transit and destination unreachable messages generated in response. The related ping utility is implemented using the ICMP echo request and echo reply messages. ICMP uses the basic support of IP as if it were a higher-level protocol; however, ICMP is actually an integral part of IP. Although ICMP messages are contained within standard IP packets, they are usually processed as a special case, distinguished from normal IP processing. In many cases, it is necessary to inspect the contents of the ICMP message and deliver the appropriate error message to the application responsible for transmitting the IP packet that prompted the ICMP message to be sent. ICMP is a network-layer protocol; this makes it a layer 3 protocol in the seven-layer OSI model . Based on the four-layer TCP/IP model, ICMP is an internet-layer protocol, which makes it a layer 2 protocol in the Internet Standard RFC 1122 TCP/IP four-layer model or a layer 3 protocol in the modern five-layer TCP/IP protocol definitions (by Kozierok, Comer, Tanenbaum, Forouzan, Kurose, Stallings). [ citation needed ] There is no port number associated with an ICMP packet, as these numbers are associated with protocols in the transport layer above, such as TCP and UDP. [ 5 ] Datagram structure [ edit ] The ICMP packet is encapsulated in an IPv4 packet. [ 3 ] The packet consists of header and data sections. Header [ edit ] The ICMP header starts after the IPv4 header and is identified by its protocol number , 1 . [ 6 ] All ICMP packets have an eight-byte header and variable-sized data section. The first four bytes of the header have fixed format, while the last four bytes depend on the type and code of the ICMP packet. [ 3 ] ICMP header format Offset Octet 0 1 2 3 Octet Bit 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 0 0 Type Code Checksum 4 32 Rest of Header Type : 8 bits ICMP type, see §   Control messages . Code : 8 bits ICMP subtype, see §   Control messages . Checksum : 16 bits Internet checksum [ 7 ] for error checking, calculated from the ICMP header and data with value 0 substituted for this field. Rest of Header : 32 bits Four-byte field, contents vary based on the ICMP type and code. Data [ edit ] ICMP error messages contain a data section that includes a copy of the entire IPv4 header, plus at least the first eight bytes of data from the IPv4 packet that caused the error message. The length of ICMP error messages should not exceed 576 bytes. [ 1 ] This data is used by the host to match the message to the appropriate process. If a higher-level protocol uses port numbers, they are assumed to be in the first eight bytes of the original datagram's data. [ 2 ] The variable size of the ICMP packet data section has been exploited . In the " Ping of death ", large or fragmented ICMP packets are used for denial-of-service attacks . ICMP data can also be used to create covert channels for communication. These channels are known as ICMP tunnels . Control messages [ edit ] Control messages are identified by the value in the type field. The code field gives additional context information for the message. Some control messages have been deprecated since the protocol was first introduced. Notable control messages [ 8 ] [ 9 ] Type Code Status Description 0 – Echo Reply [ 2 ] :   14   0 Echo reply (used to ping ) 1 and 2 unassigned Reserved 3 – Destination Unreachable [ 2 ] :   4   [ 8 ] 0 Destination network unreachable 1 Destination host unreachable 2 Destination protocol unreachable 3 Destination port unreachable 4 Fragmentation required, and DF flag set 5 Source route failed 6 Destination network unknown 7 Destination host unknown 8 Source host isolated 9 Network administratively prohibited 10 Host administratively prohibited 11 Network unreachable for ToS 12 Host unreachable for ToS 13 Communication administratively prohibited 14 Host Precedence Violation 15 Precedence cutoff in effect 4 – Source Quench 0 deprecated [ 10 ] Source quench (congestion control) 5 – Redirect Message 0 Redirect Datagram for the Network 1 Redirect Datagram for the Host 2 Redirect Datagram for the ToS & network 3 Redirect Datagram for the ToS & host 6 deprecated [ 11 ] Alternate Host Address 7 unassigned Reserved 8 – Echo Request 0 Echo request (used to ping ) 9 – Router Advertisement 0 Router Advertisement 10 – Router Solicitation 0 Router discovery/selection/solicitation 11 – Time Exceeded [ 2 ] :   6   0 Time to live (TTL) expired in transit 1 Fragment reassembly time exceeded 12 – Parameter Problem: Bad IP header 0 Pointer indicates the error 1 Missing a required option 2 Bad length 13 – Timestamp 0 Timestamp 14 – Timestamp Reply 0 Timestamp reply 15 – Information Request 0 deprecated [ 11 ] Information Request 16 – Information Reply 0 deprecated [ 11 ] Information Reply 17 – Address Mask Request 0 deprecated [ 11 ] Address Mask Request 18 – Address Mask Reply 0 deprecated [ 11 ] Address Mask Reply 19 unassigned Reserved for security 20 through 29 unassigned Reserved for robustness experiment 30 – Traceroute 0 deprecated [ 11 ] Information Request 31 deprecated [ 11 ] Datagram Conversion Error 32 deprecated [ 11 ] Mobile Host Redirect 33 deprecated [ 11 ] Where-Are-You (originally meant for IPv6 ) 34 deprecated [ 11 ] Here-I-Am (originally meant for IPv6 ) 35 deprecated [ 11 ] Mobile Registration Request 36 deprecated [ 11 ] Mobile Registration Reply 37 deprecated [ 11 ] Domain Name Request 38 deprecated [ 11 ] Domain Name Reply 39 deprecated [ 11 ] SKIP Algorithm Discovery Protocol, Simple Key-Management for Internet Protocol 40 Photuris , Security failures 41 Experimental ICMP for experimental mobility protocols such as Seamoby . [ 12 ] 42 – Extended Echo Request [ 13 ] 0 Request Extended Echo 43 – Extended Echo Reply [ 13 ] 0 No Error 1 Malformed Query 2 No Such Interface 3 No Such Table Entry 4 Multiple Interfaces Satisfy Query 44 through 252 unassigned Reserved 253 Experimental RFC3692-style Experiment 1 [ 14 ] 254 Experimental RFC3692-style Experiment 2 [ 14 ] 255 unassigned Reserved Source quench [ edit ] Source Quench requests that the sender decrease the rate of messages sent to a router or host. This message may be generated if a router or host does not have sufficient buffer space to process the request, or may occur if the router or host buffer is approaching its limit. Data is sent at a very high speed from a host or from several hosts at the same time to a particular router on a network. Although a router has buffering capabilities, the buffering is limited to within a specified range. The router cannot queue any more data than the capacity of the limited buffering space. Thus, if the queue gets filled up, incoming data is discarded until the queue is no longer full. But as no acknowledgement mechanism is present in the network layer, the client does not know whether the data has reached the destination successfully. Hence, some remedial measures should be taken by the network layer to avoid these kinds of situations. These measures are referred to as source quench. In a source quench mechanism, the router sees that the incoming data rate is much faster than the outgoing data rate and sends an ICMP message to the clients, informing them that they should slow down their data transfer speeds or wait for a certain amount of time before attempting to send more data. When a client receives this message, it automatically slows down the outgoing data rate or waits for a sufficient amount of time, which enables the router to empty the queue. Thus, the source quench ICMP message acts as flow control in the network layer. Since research suggested that "ICMP Source Quench [was] an ineffective (and unfair) antidote for congestion", [ 10 ] routers' creation of source quench messages was deprecated in 1995 by RFC 1812. Furthermore, forwarding of and any kind of reaction to (flow control actions) source quench messages was deprecated from 2012 by RFC 6633. Source quench message [ 2 ] :   9   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 4 Code = 0 Checksum unused IP header and first 8 bytes of original datagram's data Where: Type must be set to 4 Code must be set to 0 IP header and additional data is used by the sender to match the reply with the associated request Redirect [ edit ] An example of how an ICMPv4 redirect message works Redirect requests data packets be sent on an alternative route. ICMP Redirect is a mechanism for routers to convey routing information to hosts. The message informs a host to update its routing information (to send packets on an alternative route). If a host tries to send data through a router (R1) and R1 sends the data on another router (R2) and a direct path from the host to R2 is available (that is, the host and R2 are on the same subnetwork ), then R1 will send a redirect message to inform the host that the best route for the destination is via R2. The host should then change its route information and send packets for that destination directly to R2. The router will still send the original datagram to the intended destination. [ 15 ] However, if the datagram contains routing information, this message will not be sent even if a better route is available. RFC 1122 states that redirects should only be sent by gateways and should not be sent by Internet hosts. Redirect message [ 2 ] :   11   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 5 Code Checksum IP address IP header and first 8 bytes of original datagram's data Where: Type must be set to 5. Code specifies the reason for the redirection, and may be one of the following: Code Description 0 Redirect for Network 1 Redirect for Host 2 Redirect for Type of Service and Network 3 Redirect for Type of Service and Host IP address is the 32-bit address of the gateway to which the redirection should be sent. IP header and additional data is included to allow the host to match the reply with the request that caused the redirection reply. Time exceeded [ edit ] Time Exceeded is generated by a gateway to inform the source of a discarded datagram due to the time to live field reaching zero. A time exceeded message may also be sent by a host if it fails to reassemble a fragmented datagram within its time limit. Time exceeded messages are used by the traceroute utility to identify gateways on the path between two hosts. Time exceeded message [ 2 ] :   5   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 11 Code Checksum unused IP header and first 8 bytes of original datagram's data Where: Type must be set to 11 Code specifies the reason for the time exceeded message, include the following: Code Description 0 Time-to-live exceeded in transit. 1 Fragment reassembly time exceeded. IP header and first 64 bits of the original payload are used by the source host to match the time exceeded message to the discarded datagram. For higher-level protocols such as UDP and TCP the 64-bit payload will include the source and destination ports of the discarded packet. Timestamp [ edit ] Timestamp is used for time synchronization. The originating timestamp is set to the time (in milliseconds since midnight) the sender last touched the packet. The receive and transmit timestamps are not used. Timestamp message [ 2 ] :   15   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 13 Code = 0 Checksum Identifier Sequence number Originate timestamp Receive timestamp Transmit timestamp Where: Type must be set to 13 Code must be set to 0 Identifier and Sequence Number can be used by the client to match the timestamp reply with the timestamp request. Originate timestamp is the number of milliseconds since midnight Universal Time (UT). If a UT reference is not available, the most-significant bit can be set to indicate a non-standard time value. Timestamp reply [ edit ] Timestamp Reply replies to a Timestamp message. It consists of the originating timestamp sent by the sender of the Timestamp as well as a receive timestamp indicating when the Timestamp was received and a transmit timestamp indicating when the Timestamp reply was sent. Timestamp reply message [ 2 ] :   15   00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 14 Code = 0 Checksum Identifier Sequence number Originate timestamp Receive timestamp Transmit timestamp Where: Type must be set to 14 Code must be set to 0 Identifier and Sequence number can be used by the client to match the reply with the request that caused the reply. Originate timestamp is the time the sender last touched the message before sending it. Receive timestamp is the time the echoer first touched it on receipt. Transmit timestamp is the time the echoer last touched the message on sending it. All timestamps are in units of milliseconds since midnight UT. If the time is not available in milliseconds or cannot be provided with respect to midnight UT, then any time can be inserted in a timestamp, provided the high-order bit of the timestamp is also set to indicate this non-standard value. The use of Timestamp and Timestamp Reply messages to synchronize the clocks of Internet nodes has largely been replaced by the UDP-based Network Time Protocol and the Precision Time Protocol . [ 16 ] Address mask request [ edit ] Address mask request is normally sent by a host to a router in order to obtain an appropriate subnet mask . Recipients should reply to this message with an Address mask reply message. Address mask request 00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 17 Code = 0 Checksum Identifier Sequence number Address mask Where: Type must be set to 17 Code must be set to 0 Address mask can be set to 0 ICMP Address Mask Request may be used as a part of reconnaissance attack to gather information on the target network, therefore ICMP Address Mask Reply is disabled by default on Cisco IOS . [ 17 ] Address mask reply [ edit ] Address mask reply is used to reply to an address mask request message with an appropriate subnet mask. Address mask reply 00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 Type = 18 Code = 0 Checksum Identifier Sequence number Address mask Where: Type must be set to 18 Code must be set to 0 Address mask should be set to the subnet mask Destination unreachable [ edit ] Destination unreachable is generated by the host or its inbound gateway [ 2 ] to inform the client that the destination is unreachable for some reason. Reasons for this message may include: the physical connection to the host does not exist (distance is infinite); the indicated protocol or port is not active; the data must be fragmented but the 'don't fragment' flag is on. [ 18 ] Unreachable TCP ports notably respond with TCP RST rather than a destination unreachable type 3 as might be expected. Destination unreachable is never reported for IP multicast transmissions. Destination unreachable message [ 2 ] :   4   [ 19 ] Offset Octet 0 1 2 3 Octet Bit 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 0 0 Type (3) Code Checksum 4 32 Unused (Length) (Next-hop MTU) 8 64 IP header and first bytes of original datagram's data ⋮ ⋮ 572 4576 With the following field contents: Type : 8 bits ; Type == 3 A value of 3 indicates 'Destination unreachable'. "}},"i":0}}]}'>Code : 8 bits This specifies the type of error, and can be any of the following: [ 8 ] Code Description 0 Network unreachable error. 1 Host unreachable error. 2 Protocol unreachable error (the designated transport protocol is not supported). 3 Port unreachable error (the designated protocol is unable to inform the host of the incoming message). 4 The datagram is too big. Packet fragmentation is required but the 'don't fragment' (DF) flag is on. 5 Source route failed error. 6 Destination network unknown error. 7 Destination host unknown error. 8 Source host isolated error. 9 The destination network is administratively prohibited. 10 The destination host is administratively prohibited. 11 The network is unreachable for Type Of Service. 12 The host is unreachable for Type Of Service. 13 Communication administratively prohibited (administrative filtering prevents packet from being forwarded). 14 Host precedence violation (indicates the requested precedence is not permitted for the combination of host or network and port). 15 Precedence cutoff in effect (precedence of datagram is below the level set by the network administrators). Unused : 8 - 32 bits ; Unused == 0 Unused, must be set to zero. If Length or Next-hop MTU are not used, they are considered part of this field. Length : 8 bits Optional. The Length field indicates the length of the original datagram data, in 32-bit words. This allows this ICMP message to be extended with extra information. If used, the original datagram data must be padded with zeroes to the nearest 32-bit boundary. Next-hop MTU : 16 bits Optional. Contains the MTU of the next-hop network if a code 4 error occurs. IP header and data : 20 - 568 bytes The IP header (20 bytes) and at most 548 bytes of the start of the original datagram (as not to exceed the minimum IPv4 reassembly buffer size). If this message is extended, then this field must contain at least 128 bytes of original datagram data (padded with zeroes if necessary). These data are included to allow the client to match the reply with the request that caused the Destination unreachable reply. Extensions [ edit ] ICMP messages can be extended with extra information. This information is carried in one or more Extension Objects, which are preceded by an ICMP Extension Header. [ 19 ] ICMP Extension Header Offset Octet 0 1 2 3 Octet Bit 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 0 0 Version Reserved Checksum 4 32 Extension Objects 8 64 ⋮ ⋮ Version : 4 bits ; Version == 2 Extension header version. Reserved : 12 bits ; Reserved == 0 Reserved. Checksum : 16 bits Checksum over this header and all extension objects. This field itself is included, so it is set to zero while performing the calculation. Extension objects have the following general structure: Extension object header Offset Octet 0 1 2 3 Octet Bit 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 0 0 Length Class-Num C-Type 4 32 (Object payload) 8 64 ⋮ ⋮ Length : 16 bits The length of the object in octets, including the header. Class-Num : 8 bits Identifies the object's class. C-Type : 8 bits Identifies the object's subtype. Object payload : Variable Optional payload. If nonempty, it contains a data structure, whose size is a multiple of 32 bits. See also [ edit ] ICMP hole punching PathPing Path MTU Discovery Smurf attack References [ edit ] 1 2 F. Baker , ed. (June 1995). Requirements for IP Version 4 Routers . Network Working Group. doi : 10.17487/RFC1812 . RFC 1812 . Proposed Standard. Obsoletes RFC   1716 and 1009 . Updated by RFC   2644 and 6633 . 1 2 3 4 5 6 7 8 9 10 11 12 J. Postel (September 1981). INTERNET CONTROL MESSAGE PROTOCOL - DARPA INTERNET PROGRAM PROTOCOL SPECIFICATION . Network Working Group. doi : 10.17487/RFC0792 . STD 5. RFC 792 . Internet Standard 5. Updates RFC   760 , 777 , IENs 109, 128. Updated by RFC   950 , 4884 , 6633 and 6918 . 1 2 3 4 Forouzan, Behrouz A. (2007). Data Communications And Networking (Fourth   ed.). Boston: McGraw-Hill. pp.   621 –630. ISBN   978-0-07-296775-3 . ↑ A. Conta; S. Deering (March 2006). M. Gupta (ed.). Internet Control Message Protocol (ICMPv6) for the Internet Protocol Version 6 (IPv6) Specification . Network Working Group. doi : 10.17487/RFC4443 . STD 89. RFC 4443 . Internet Standard 89. Obsoletes RFC   2463 . Updates RFC   2780 . Updated by RFC   4884 . ↑ "The OSI Model's Seven Layers Defined and Functions Explained" . Microsoft Support . Retrieved 2014-12-28 . ↑ "Protocol Numbers" . Internet Assigned Numbers Authority . Retrieved 2011-06-23 . ↑ R. Braden ; D. Borman; C. Partridge (September 1988). Computing the Internet Checksum . Network Working Group. doi : 10.17487/RFC1071 . RFC 1071 . Informational. Updated by RFC   1141 . 1 2 3 "Internet Control Message Protocol (ICMP) Parameters" . IANA. 2012-09-21 . Retrieved 2013-01-07 . ↑ Kurose, J.F; Ross, K.W. (2006). Computer Networking: A Top-Down Approach . World student series. Addison-Wesley. ISBN   9780321418494 . 1 2 F. Gont (May 2012). Deprecation of ICMP Source Quench Messages . Internet Engineering Task Force . doi : 10.17487/RFC6633 . ISSN   2070-1721 . RFC 6633 . Proposed Standard. Updates RFC   792 , 1122 and 1812 . 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 F. Gont; C. Pignataro (April 2013). Formally Deprecating Some ICMPv4 Message Types . Internet Engineering Task Force . doi : 10.17487/RFC6918 . ISSN   2070-1721 . RFC 6918 . Proposed Standard. Obsoletes RFC   1788 . Updates RFC   792 and 950 . ↑ J. Kempf (July 2005). Instructions for Seamoby and Experimental Mobility Protocol IANA Allocations . IETF . doi : 10.17487/RFC4065 . RFC 4065 . Experimental. 1 2 R. Bonica; R. Thomas; J. Linkova; C. Lenart; M. Boucadair (February 2018). PROBE: A Utility for Probing Interfaces . Internet Engineering Task Force . doi : 10.17487/RFC8335 . ISSN   2070-1721 . RFC 8335 . Proposed Standard. Updates RFC   4884 . 1 2 B. Fenner (November 2006). Experimental Values in IPv4, IPv6, ICMPv4, ICMPv6, UDP, and TCP Headers . IETF Network Working Group. doi : 10.17487/RFC4727 . RFC 4727 . Proposed Standard. ↑ "When Are ICMP Redirects Sent?" . Cisco Systems . 2008-06-28 . Retrieved 2013-08-15 . ↑ D.L. Mills (September 1985). Network Time Protocol (NTP) . IETF . doi : 10.17487/RFC0958 . RFC 958 . It is evolved from the Time Protocol and the ICMP Timestamp message and is a suitable replacement for both. ↑ "Cisco IOS IP Command Reference, Volume 1 of 4: Addressing and Services, Release 12.3 - IP Addressing and Services Commands: ip mask-reply through ip web-cache" . Cisco Systems . Archived from the original on 2013-01-02 . Retrieved 2013-01-07 . ↑ J. Mogul; S. Deering (November 1990). Path MTU Discovery . Network Working Group. doi : 10.17487/RFC1191 . RFC 1191 . Draft Standard. Obsoletes RFC   1063 . 1 2 R. Bonica; D. Gan; D. Tappan; C. Pignataro (April 2007). Extended ICMP to Support Multi-Part Messages . Network Working Group. doi : 10.17487/RFC4884 . RFC 4884 . Proposed Standard. Updates RFC   792 and 4443 . Updated by RFC   8335 . External links [ edit ] Wikiversity has learning resources about Internet Control Message Protocol IANA protocol numbers Explanation of ICMP Redirect Behavior at the Wayback Machine (archived 2015-01-10) Authority control databases GND Retrieved from " https://en.wikipedia.org/w/index.php?title=Internet_Control_Message_Protocol&oldid=1341912827 " Categories : Internet protocols Internet Standards Internet layer protocols Network layer protocols Hidden categories: Articles with short description Short description is different from Wikidata All articles with unsourced statements Articles with unsourced statements from January 2023 Webarchive template wayback links This page was last edited on 5 March 2026, at 21:58  (UTC) . Page was rendered with Parsoid . Text is available under the Creative Commons Attribution-ShareAlike 4.0 License ; additional terms may apply. By using this site, you agree to the Terms of Use and Privacy Policy . Wikipedia® is a registered trademark of the Wikimedia Foundation, Inc. , a non-profit organization. Privacy policy About Wikipedia Disclaimers Contact Wikipedia Legal & safety contacts Code of Conduct Developers Statistics Cookie statement Mobile view Search Search Toggle the table of contents Internet Control Message Protocol 45 languages Add topic